#include <iostream>
#include <cassert>

#include <iostream>
#include <cstdint>
#include <cassert>

char nibble_to_hex(uint8_t i) {
    char digits[] = "0123456789abcdef";
    assert(0x0 <= i && i <= 0xf);
    return digits[i];
}

void print_in_hex(uint8_t byte) {
    std::cout << nibble_to_hex(byte >> 4) << nibble_to_hex(byte & 0xf);
}

//    
const uint8_t* as_bytes(const void* data) {
    return reinterpret_cast<const uint8_t*>(data);
}

//     
void print_in_hex(const void* data, size_t size) {
    const uint8_t* bytes = as_bytes(data);
    for (size_t i = 0; i < size; i++) {
        print_in_hex(bytes[i]);

        //   :   ,  16   .
        if ((i + 1) % 16 == 0) {
            std::cout << '\n';
        } else {
            std::cout << ' ';
        }
    }
    std::cout << std::endl;
}

//          
char bit_digit(uint8_t byte, uint8_t bit) {
    if (byte & (0x1 << bit)) {
        return '1';
    }
    return '0';
}

int main() {
    uint8_t u8 = 0x42;
    uint16_t u16 = 0x42;
    uint32_t u32 = 0x42;

    std::cout << "u8 bytes: ";
    print_in_hex(&u8, sizeof(u8));

    std::cout << "\nu8 binary: ";
    for (int i = 7; i >= 0; --i) {
        std::cout << bit_digit(u8, i);
    }
    std::cout << '\n';

    std::cout << "\nu16 bytes: ";
    print_in_hex(&u16, sizeof(u16));

    std::cout << "\nu16 binary: ";
    for (int i = 15; i >= 0; --i) {
        std::cout << bit_digit(u16, i);
    }
    std::cout << '\n';

    std::cout << "\nu32 bytes: ";
    print_in_hex(&u32, sizeof(u32));

    std::cout << "\nu32 binary: ";
    for (int i = 31; i >= 0; --i) {
        std::cout << bit_digit(u32, i);
    }
    std::cout << '\n';

    return 0;
}


